package com.fp.persistence.pgeneral.menu;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import javax.persistence.Query;

import java.io.Serializable;
import javax.persistence.Table;

import com.fp.core.exception.CoreException;
import com.fp.dto.hb.HibernateBean;
import com.fp.persistence.commondb.exception.CommondbException;

import java.lang.reflect.Field;
import java.util.List;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEMENULEVEL*/
@Entity(name="TgeneMenuLevel")
@Table(name="TGENEMENULEVEL")
public class TgeneMenuLevel extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneMenuLevel
*/
@EmbeddedId
private TgeneMenuLevelKey pk;
@Column(name="PRESENTATIONORDER", nullable=true)

/**
* Orden de presentacion de la agrupacion en el primer nivel del menu
*/
private Integer presentationorder;

@Column(name="HAVESUBLEVEL", nullable=true)

/**
* Y,  Indica que tiene un subnivel de menu.
*/
private String havesublevel;

/**Contructor por defecto*/
public TgeneMenuLevel(){
}
/**Contructor de TgeneMenuLevel
@param pPk Clave Primaria del entity
*/
public TgeneMenuLevel(TgeneMenuLevelKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneMenuLevel
*/
public static TgeneMenuLevel find(EntityManager pEntityManager,TgeneMenuLevelKey pKey) throws Exception{
    TgeneMenuLevel obj = pEntityManager.find(TgeneMenuLevel.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneMenuLevel
@return El objeto que referencia a la Clave primaria de TgeneMenuLevel
*/
public TgeneMenuLevelKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneMenuLevel
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneMenuLevel
*/
public void setPk(TgeneMenuLevelKey pPk){
  pk=pPk;
}
/**Obtiene el valor de presentationorder
@return valor de presentationorder*/
public Integer getPresentationorder(){
  return presentationorder;
}
/**Fija el valor de presentationorder
@param pPresentationorder nuevo Valor de presentationorder*/
public void setPresentationorder(Integer pPresentationorder){
  presentationorder=pPresentationorder;
}

/**Obtiene el valor de havesublevel
@return valor de havesublevel*/
public String getHavesublevel(){
  return havesublevel;
}
/**Fija el valor de havesublevel
@param pHavesublevel nuevo Valor de havesublevel*/
public void setHavesublevel(String pHavesublevel){
  havesublevel=pHavesublevel;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneMenuLevel))return false;
    TgeneMenuLevel that = (TgeneMenuLevel) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneMenuLevel
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneMenuLevel
*/
public Object createInstance(){
 TgeneMenuLevel instance=new TgeneMenuLevel();	
 instance.setPk(new TgeneMenuLevelKey());
 return instance;
}
/**Clona la entidad TgeneMenuLevel
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneMenuLevel p=(TgeneMenuLevel)this.clone();
  p.setPk((TgeneMenuLevelKey)this.pk.cloneMe());
  return p;
}
	
	//METODOS MANUALES
	/** Sentencia que devuelve un registro de TgeneMenuLevel. */
	private static final String JPQL_MENU_LEVEL = "from TgeneMenuLevel tmg  " + " where tmg.pk.menucode = :menucode"
        + " order by tmg.presentationorder ";
	/**
     * Metodo que entrega la definicion del primer nivel del menu.
     * 
     * @param pMenucode Codigo de menu.
     * @return List<TgeneMenuLevel>
     * @throws Exception
     */
    @SuppressWarnings(com.fp.common.helper.Constant.VUNCHECKED)
    public static List<TgeneMenuLevel> findByMenuCode(EntityManager pEntityManager, Integer pMenucode) throws Exception {
        List<TgeneMenuLevel> lmenu = null;
        Query qry = pEntityManager.createQuery(TgeneMenuLevel.JPQL_MENU_LEVEL);
        qry.setParameter("menucode", pMenucode);
        lmenu = qry.getResultList();
        return lmenu;
    }
	
}
